/*
 * Copyright 2014 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef CHAT_H
#define CHAT_H

#include "RenderObject.h"
#include <deque>

class GameState;

struct ChatMessage
{
	Uint32 timestamp;
	RenderObject renderObject;
};

class Chat
{
public:
	Chat();
	void addMessage(const std::string& message, Color color = CHAT_COLOR);
	void update();
	void setGameState(GameState* gameState);
	void toggle();
	void toggle(bool enable);
	bool isEnabled() const;
	void clear();
private:
	void setSpecialMessage(const std::string& message);
	std::deque<ChatMessage> messages;
	bool needUpdate;
	GameState* gameState;
	bool enabled;
	ChatMessage specialMessage;
	bool specialMessageVisible;
};

#endif
